<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\land;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\land\Land;
use app\common\lists\ListsSearchInterface;


/**
 * Land列表
 * Class LandLists
 * @package app\adminapi\listsland
 */
class LandLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2023/11/22 16:35
     */
    public function setSearch(): array
    {
        return [
            '%like%' => ['title'],
            '=' => ['user_id', 'master_name', 'master_phone'],
        ];
    }

    public function userSearch(): array
    {
        $userWhere['user_id'] = -1;
        // 超级管理员数据
        if ($this->adminInfo['root'] && !$this->adminInfo['user_id']) {
            unset($userWhere['user_id']);
        }
        // 普通用户数据
        if (!$this->adminInfo['root'] && $this->adminInfo['user_id']) {
            $userWhere['user_id'] = $this->adminInfo['user_id'];
        }
        return $userWhere;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2023/11/22 16:35
     */
    public function lists(): array
    {
        
        return Land::where($this->searchWhere)->where($this->userSearch())->with('user')
            ->field(['id', 'user_id', 'title', 'address', 'total_area', 'residual_area', 'province_code', 'province_name', 'city_code', 'city_name', 'county_code', 'county_name', 'town_code', 'town_name', 'village_code', 'village_name', 'group_code', 'group_name', 'master_name', 'master_phone', 'pic'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()->each(function($item, $key){
                $item['root'] = $this->adminInfo['root'] ?? 0;
                return $item;
            })
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2023/11/22 16:35
     */
    public function count(): int
    {
        return Land::where($this->searchWhere)->where($this->userSearch())->count();
    }

}